<?php
/**
* SwipeHQ Checkout functions
*
* @copyright Copyright (c) 2012 OptimizerHQ Ltd.
*/

function shq_post_to_url($url, $data) {
     $ch = curl_init ($url);
     curl_setopt ($ch, CURLOPT_POST, 1);
     curl_setopt ($ch, CURLOPT_POSTFIELDS, $data);
     curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
     curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,0);
     curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,0);
     $response = curl_exec ($ch);
     curl_close ($ch);
     return $response;
}

  
/**
 * Transaction verification
 * 
 * @param string $transaction_id
 * @return boolean
 */
function verify_transaction($transaction_id) {

    //parameters for transaction verification
    $data = array (
        'merchant_id'       => MODULE_PAYMENT_SWIPEHQ_MERCHANT_ID,
        'api_key'           => MODULE_PAYMENT_SWIPEHQ_API_KEY,
        'transaction_id'    => $transaction_id
    );

    $api_url = trim(MODULE_PAYMENT_SWIPEHQ_API_URL, '/');
    
    $response = shq_post_to_url($api_url . '/verifyTransaction.php', $data);

    if (!empty($response)) {
        $response_data = json_decode($response);

        if ($response_data->response_code == 200 && $response_data->data->transaction_id == $transaction_id) {
            return true;
        }
    }
    return false;
}