<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2008 osCommerce

  Released under the GNU General Public License
*/

require_once DIR_FS_CATALOG . 'ext/modules/payment/swipehq/functions.php';

class swipehq {
    var $code, $title, $description, $enabled;
    
// class constructor
    function swipehq() {
      global $order;

      $this->code = 'swipehq';
      $this->title = MODULE_PAYMENT_SWIPEHQ_TEXT_TITLE;
      $this->public_title = MODULE_PAYMENT_SWIPEHQ_TEXT_PUBLIC_TITLE;
      $this->description = MODULE_PAYMENT_SWIPEHQ_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_SWIPEHQ_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_SWIPEHQ_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_SWIPEHQ_PREPARE_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_SWIPEHQ_PREPARE_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_SWIPEHQ_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SWIPEHQ_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    /**
     * Displays payment method name along with Credit Card Information Submission Fields (if any) on the Checkout Payment Page
     *
     * @return array
      */
    function selection() {
      return array('id' => $this->code,
                   'module' => MODULE_PAYMENT_SWIPEHQ_TEXT_CATALOG_LOGO,
                   'icon' => MODULE_PAYMENT_SWIPEHQ_TEXT_CATALOG_LOGO
                   );
    }

    function pre_confirmation_check() {
      global $cartID, $cart;

      if (empty($cart->cartID)) {
        $cartID = $cart->cartID = $cart->generate_cart_id();
      }

      if (!tep_session_is_registered('cartID')) {
        tep_session_register('cartID');
      }
    }

    function confirmation() {
        return false;
    }

    function process_button() { 
        return '';
    }

    function before_process() {
        global $order;
        
        $order_id = $this->_create_order();
        
        if (!empty($order_id)) {
            $currency = !empty($order->info['currency']) ? $order->info['currency'] : false;
            $acceptedCurrencies = $this->getAcceptedCurrencies();
            
            if (in_array($currency, $acceptedCurrencies)) {
                
                $price = round($order->info['total']*$order->info['currency_value'], 2);
                
                //get list of ordered products
                $products = '';
                $products_list = $order->products;
                foreach ($products_list as $product) {
                    $products .= $product['qty'] . ' x ' . $product['name'] . ($product != end($products_list) ? '<br />' : '');
                }

                //get product ID using TransactionIdentifier API
                $params = array (
                    'merchant_id'           => MODULE_PAYMENT_SWIPEHQ_MERCHANT_ID,
                    'api_key'               => MODULE_PAYMENT_SWIPEHQ_API_KEY,
                    'td_item'               => 'Order ID' . $order_id,
                    'td_description'        => $products,
                    'td_amount'             => $price,
                    'td_currency'           => $currency,
                    'td_default_quantity'   => 1,
                    'td_user_data'          => $order_id
                );
                
                $customer = $order->customer;
                if(!empty($customer)){
                    if(!empty($customer['email_address'])){
                        $params['td_email'] = $customer['email_address'];
                    }
                }
                
                $api_url = trim(MODULE_PAYMENT_SWIPEHQ_API_URL, '/');
                
                $response = shq_post_to_url($api_url.'/createTransactionIdentifier.php', $params);
                $response_data = json_decode($response); 
                
                $payment_page_url = trim(MODULE_PAYMENT_SWIPEHQ_PAYMENT_PAGE_URL, '/');

                if ($response_data->response_code == 200 && !empty($response_data->data->identifier)) {
                    header('Location: '.$payment_page_url.'?checkout=true&identifier_id=' . $response_data->data->identifier);
                    exit;
                }
            }else{
				die('The Swipe payment method does not support currency: '.$currency.'. Swipe supports these currencies: '.join(', ', $acceptedCurrencies).'.');
            }
        }
        echo MODULE_PAYMENT_SWIPEHQ_TEXT_ERROR_MESSAGE;
        exit;
    }
    
    /**
     * Creates order in DB
     * (code part from checkout_process.php lines 83-240)
     * 
     * @return integer created order ID
     */
    function _create_order() {
      global $customer_id, $order, $order_totals, $sendto, $billto, $languages_id, $payment, $currencies, $cart, $cart_ChronoPay_ID;
      global $$payment;
        
        $sql_data_array = array('customers_id' => $customer_id,
                                'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
                                'customers_company' => $order->customer['company'],
                                'customers_street_address' => $order->customer['street_address'],
                                'customers_suburb' => $order->customer['suburb'],
                                'customers_city' => $order->customer['city'],
                                'customers_postcode' => $order->customer['postcode'], 
                                'customers_state' => $order->customer['state'], 
                                'customers_country' => $order->customer['country']['title'], 
                                'customers_telephone' => $order->customer['telephone'], 
                                'customers_email_address' => $order->customer['email_address'],
                                'customers_address_format_id' => $order->customer['format_id'], 
                                'delivery_name' => trim($order->delivery['firstname'] . ' ' . $order->delivery['lastname']),
                                'delivery_company' => $order->delivery['company'],
                                'delivery_street_address' => $order->delivery['street_address'], 
                                'delivery_suburb' => $order->delivery['suburb'], 
                                'delivery_city' => $order->delivery['city'], 
                                'delivery_postcode' => $order->delivery['postcode'], 
                                'delivery_state' => $order->delivery['state'], 
                                'delivery_country' => $order->delivery['country']['title'], 
                                'delivery_address_format_id' => $order->delivery['format_id'], 
                                'billing_name' => $order->billing['firstname'] . ' ' . $order->billing['lastname'], 
                                'billing_company' => $order->billing['company'],
                                'billing_street_address' => $order->billing['street_address'], 
                                'billing_suburb' => $order->billing['suburb'], 
                                'billing_city' => $order->billing['city'], 
                                'billing_postcode' => $order->billing['postcode'], 
                                'billing_state' => $order->billing['state'], 
                                'billing_country' => $order->billing['country']['title'], 
                                'billing_address_format_id' => $order->billing['format_id'], 
                                'payment_method' => $order->info['payment_method'], 
                                'cc_type' => $order->info['cc_type'], 
                                'cc_owner' => $order->info['cc_owner'], 
                                'cc_number' => $order->info['cc_number'], 
                                'cc_expires' => $order->info['cc_expires'], 
                                'date_purchased' => 'now()', 
                                'orders_status' => $order->info['order_status'], 
                                'currency' => $order->info['currency'], 
                                'currency_value' => $order->info['currency_value']);
        tep_db_perform(TABLE_ORDERS, $sql_data_array);
        $insert_id = tep_db_insert_id();
        for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
          $sql_data_array = array('orders_id' => $insert_id,
                                  'title' => $order_totals[$i]['title'],
                                  'text' => $order_totals[$i]['text'],
                                  'value' => $order_totals[$i]['value'], 
                                  'class' => $order_totals[$i]['code'], 
                                  'sort_order' => $order_totals[$i]['sort_order']);
          tep_db_perform(TABLE_ORDERS_TOTAL, $sql_data_array);
        }

        $customer_notification = (SEND_EMAILS == 'true') ? '1' : '0';
        $sql_data_array = array('orders_id' => $insert_id, 
                                'orders_status_id' => $order->info['order_status'], 
                                'date_added' => 'now()', 
                                'customer_notified' => $customer_notification,
                                'comments' => $order->info['comments']);
        tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

      // initialized for the email confirmation
        $products_ordered = '';

        for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
      // Stock Update - Joao Correia
          if (STOCK_LIMITED == 'true') {
            if (DOWNLOAD_ENABLED == 'true') {
              $stock_query_raw = "SELECT products_quantity, pad.products_attributes_filename 
                                  FROM " . TABLE_PRODUCTS . " p
                                  LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                   ON p.products_id=pa.products_id
                                  LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                                   ON pa.products_attributes_id=pad.products_attributes_id
                                  WHERE p.products_id = '" . tep_get_prid($order->products[$i]['id']) . "'";
      // Will work with only one option for downloadable products
      // otherwise, we have to build the query dynamically with a loop
              $products_attributes = (isset($order->products[$i]['attributes'])) ? $order->products[$i]['attributes'] : '';
              if (is_array($products_attributes)) {
                $stock_query_raw .= " AND pa.options_id = '" . (int)$products_attributes[0]['option_id'] . "' AND pa.options_values_id = '" . (int)$products_attributes[0]['value_id'] . "'";
              }
              $stock_query = tep_db_query($stock_query_raw);
            } else {
              $stock_query = tep_db_query("select products_quantity from " . TABLE_PRODUCTS . " where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
            }
            if (tep_db_num_rows($stock_query) > 0) {
              $stock_values = tep_db_fetch_array($stock_query);
      // do not decrement quantities if products_attributes_filename exists
              if ((DOWNLOAD_ENABLED != 'true') || (!$stock_values['products_attributes_filename'])) {
                $stock_left = $stock_values['products_quantity'] - $order->products[$i]['qty'];
              } else {
                $stock_left = $stock_values['products_quantity'];
              }
              tep_db_query("update " . TABLE_PRODUCTS . " set products_quantity = '" . (int)$stock_left . "' where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
              if ( ($stock_left < 1) && (STOCK_ALLOW_CHECKOUT == 'false') ) {
                tep_db_query("update " . TABLE_PRODUCTS . " set products_status = '0' where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
              }
            }
          }

      // Update products_ordered (for bestsellers list)
          tep_db_query("update " . TABLE_PRODUCTS . " set products_ordered = products_ordered + " . sprintf('%d', $order->products[$i]['qty']) . " where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");

          $sql_data_array = array('orders_id' => $insert_id, 
                                  'products_id' => tep_get_prid($order->products[$i]['id']), 
                                  'products_model' => $order->products[$i]['model'], 
                                  'products_name' => $order->products[$i]['name'], 
                                  'products_price' => $order->products[$i]['price'], 
                                  'final_price' => $order->products[$i]['final_price'], 
                                  'products_tax' => $order->products[$i]['tax'], 
                                  'products_quantity' => $order->products[$i]['qty']);
          tep_db_perform(TABLE_ORDERS_PRODUCTS, $sql_data_array);
          $order_products_id = tep_db_insert_id();

      //------insert customer choosen option to order--------
          $attributes_exist = '0';
          $products_ordered_attributes = '';
          if (isset($order->products[$i]['attributes'])) {
            $attributes_exist = '1';
            for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
              if (DOWNLOAD_ENABLED == 'true') {
                $attributes_query = "select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix, pad.products_attributes_maxdays, pad.products_attributes_maxcount , pad.products_attributes_filename 
                                     from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa 
                                     left join " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                                      on pa.products_attributes_id=pad.products_attributes_id
                                     where pa.products_id = '" . (int)$order->products[$i]['id'] . "' 
                                      and pa.options_id = '" . (int)$order->products[$i]['attributes'][$j]['option_id'] . "' 
                                      and pa.options_id = popt.products_options_id 
                                      and pa.options_values_id = '" . (int)$order->products[$i]['attributes'][$j]['value_id'] . "' 
                                      and pa.options_values_id = poval.products_options_values_id 
                                      and popt.language_id = '" . (int)$languages_id . "' 
                                      and poval.language_id = '" . (int)$languages_id . "'";
                $attributes = tep_db_query($attributes_query);
              } else {
                $attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa where pa.products_id = '" . (int)$order->products[$i]['id'] . "' and pa.options_id = '" . (int)$order->products[$i]['attributes'][$j]['option_id'] . "' and pa.options_id = popt.products_options_id and pa.options_values_id = '" . (int)$order->products[$i]['attributes'][$j]['value_id'] . "' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '" . (int)$languages_id . "' and poval.language_id = '" . (int)$languages_id . "'");
              }
              $attributes_values = tep_db_fetch_array($attributes);

              $sql_data_array = array('orders_id' => $insert_id, 
                                      'orders_products_id' => $order_products_id, 
                                      'products_options' => $attributes_values['products_options_name'],
                                      'products_options_values' => $attributes_values['products_options_values_name'], 
                                      'options_values_price' => $attributes_values['options_values_price'], 
                                      'price_prefix' => $attributes_values['price_prefix']);
              tep_db_perform(TABLE_ORDERS_PRODUCTS_ATTRIBUTES, $sql_data_array);

              if ((DOWNLOAD_ENABLED == 'true') && isset($attributes_values['products_attributes_filename']) && tep_not_null($attributes_values['products_attributes_filename'])) {
                $sql_data_array = array('orders_id' => $insert_id, 
                                        'orders_products_id' => $order_products_id, 
                                        'orders_products_filename' => $attributes_values['products_attributes_filename'], 
                                        'download_maxdays' => $attributes_values['products_attributes_maxdays'], 
                                        'download_count' => $attributes_values['products_attributes_maxcount']);
                tep_db_perform(TABLE_ORDERS_PRODUCTS_DOWNLOAD, $sql_data_array);
              }
              $products_ordered_attributes .= "\n\t" . $attributes_values['products_options_name'] . ' ' . $attributes_values['products_options_values_name'];
            }
          }
      //------insert customer choosen option eof ----
          $products_ordered .= $order->products[$i]['qty'] . ' x ' . $order->products[$i]['name'] . ' (' . $order->products[$i]['model'] . ') = ' . $currencies->display_price($order->products[$i]['final_price'], $order->products[$i]['tax'], $order->products[$i]['qty']) . $products_ordered_attributes . "\n";
        }
        
        //store data to session for using in the callback script
        $_SESSION['shq_products_ordered'] = $products_ordered;
        $_SESSION['shq_order_totals'] = $order_totals;
        $_SESSION['shq_insert_id'] = $insert_id;
        
        return $insert_id;
    }

    function after_process() {
        return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SWIPEHQ_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      $check_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Preparing [SwipeHQ]' limit 1");

      if (tep_db_num_rows($check_query) < 1) {
        $status_query = tep_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
        $status = tep_db_fetch_array($status_query);

        $status_id = $status['status_id']+1;

        $languages = tep_get_languages();

        for ($i=0, $n=sizeof($languages); $i<$n; $i++) {
          tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $languages[$i]['id'] . "', 'Preparing [SwipeHQ]')");
        }

        $flags_query = tep_db_query("describe " . TABLE_ORDERS_STATUS . " public_flag");
        if (tep_db_num_rows($flags_query) == 1) {
          tep_db_query("update " . TABLE_ORDERS_STATUS . " set public_flag = 0 and downloads_flag = 0 where orders_status_id = '" . $status_id . "'");
        }
      } else {
        $check = tep_db_fetch_array($check_query);

        $status_id = $check['orders_status_id'];
      }
      
      
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable SwipeHQ Checkout Payment Module<script src=\"../includes/modules/payment/check_config.js\"></script>', 'MODULE_PAYMENT_SWIPEHQ_STATUS', 'True', 'Do you want to accept SwipeHQ Checkout payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_SWIPEHQ_MERCHANT_ID', '', 'Find this in your Swipe Merchant login under Settings -> API Credentials', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('API Key', 'MODULE_PAYMENT_SWIPEHQ_API_KEY', '', 'Find this in your Swipe Merchant login under Settings -> API Credentials', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('API Url', 'MODULE_PAYMENT_SWIPEHQ_API_URL', '', 'Find this in your Swipe Merchant login under Settings -> API Credentials', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Payment Page Url', 'MODULE_PAYMENT_SWIPEHQ_PAYMENT_PAGE_URL', '', 'Find this in your Swipe Merchant login under Settings -> API Credentials', '6', '0', now())");
      
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Test Mode', 'MODULE_PAYMENT_SWIPEHQ_TEST_MODE', 'Off', 'Use test mode for processing orders', '6', '0', 'tep_cfg_select_option(array(\'On\', \'Off\'), ', now())");
      
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_SWIPEHQ_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '0', 'tep_get_zone_class_title', 'tep_cfg_pull_down_order_statuses(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_SWIPEHQ_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Unpaid Order Status', 'MODULE_PAYMENT_SWIPEHQ_ORDER_STATUS_ID', '1', 'Set the status of unpaid orders made with this payment module to this value (recommended: Pending [1]).', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Paid Order Status', 'MODULE_PAYMENT_SWIPEHQ_PROCESSING_STATUS_ID', '2', 'Set the status of orders made with this payment module to this value (recommended: Processing [2])', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Test Order Status', 'MODULE_PAYMENT_SWIPEHQ_TEST_STATUS_ID', '1', 'Set the status of orders made with test mode turning on (recommended: Pending [1])', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }
    
    /**
     * Remove the module and all its settings
     *
     */
    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
      // Is it better to do: configuration_key ILIKE 'MODULE_PAYMENT_SWIPEHQ%' ?
      // no, we might as well call keys(), as keys() is required by oscommerce
    }

    /**
     * Internal list of configuration keys used for configuration of the module
     *
     * @return array
     */
    function keys() {
      return array(
          'MODULE_PAYMENT_SWIPEHQ_STATUS',
      	  'MODULE_PAYMENT_SWIPEHQ_MERCHANT_ID',
          'MODULE_PAYMENT_SWIPEHQ_API_KEY',
          'MODULE_PAYMENT_SWIPEHQ_API_URL',
      	  'MODULE_PAYMENT_SWIPEHQ_PAYMENT_PAGE_URL',
      	  'MODULE_PAYMENT_SWIPEHQ_TEST_MODE',
          'MODULE_PAYMENT_SWIPEHQ_ZONE', 
          'MODULE_PAYMENT_SWIPEHQ_ORDER_STATUS_ID',
          'MODULE_PAYMENT_SWIPEHQ_PROCESSING_STATUS_ID',
          'MODULE_PAYMENT_SWIPEHQ_TEST_STATUS_ID',
          'MODULE_PAYMENT_SWIPEHQ_SORT_ORDER');
    }
    
    
    /**
     * @return array of string currency code
     */
    public function getAcceptedCurrencies(){
    	$api_url = trim(MODULE_PAYMENT_SWIPEHQ_API_URL, '/');
    	
    	$params = array(
			'merchant_id' 	=> MODULE_PAYMENT_SWIPEHQ_MERCHANT_ID,
			'api_key' 		=> MODULE_PAYMENT_SWIPEHQ_API_KEY,
    	);
    	
		$response = shq_post_to_url($api_url.'/fetchCurrencyCodes.php', $params);
		$response_data = json_decode($response, true); 
		
		$r = $response_data['data'];
		return $r;
    }
    
}
