<?php
/**
 * User redirection from SwipeHQ Checkout gateway to order confirmation page
 */

/*** init data ***/
  include('includes/application_top.php');
  
require (DIR_WS_LANGUAGES . $language . '/modules/payment/swipehq.php');

$ssl_str = 'NONSSL';
if (ENABLE_SSL != 'false') {
   $ssl_str = 'SSL';
}

// if the customer is not logged on, redirect them to the login page
  if (!tep_session_is_registered('customer_id')) {
    $navigation->set_snapshot(array('mode' => 'SSL', 'page' => FILENAME_CHECKOUT_PAYMENT));
    tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
  }

// if there is nothing in the customers cart, redirect them to the shopping cart page
  if ($cart->count_contents() < 1) {
    tep_redirect(tep_href_link(FILENAME_SHOPPING_CART));
  }

// if no shipping method has been selected, redirect the customer to the shipping method selection page
  if (!tep_session_is_registered('shipping') || !tep_session_is_registered('sendto')) {
    tep_redirect(tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
  }

  if ( (tep_not_null(MODULE_PAYMENT_INSTALLED)) && (!tep_session_is_registered('payment')) ) {
    tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
 }

// avoid hack attempts during the checkout procedure by checking the internal cartID
  if (isset($cart->cartID) && tep_session_is_registered('cartID')) {
    if ($cart->cartID != $cartID) {
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
    }
  }

  include(DIR_WS_LANGUAGES . $language . '/' . FILENAME_CHECKOUT_PROCESS);

// load selected payment module
  require(DIR_WS_CLASSES . 'payment.php');
  $payment_modules = new payment($payment);

// load the selected shipping module
  require(DIR_WS_CLASSES . 'shipping.php');
  $shipping_modules = new shipping($shipping);
  
  require(DIR_WS_CLASSES . 'order.php');
/*** END init data ***/
  
if (MODULE_PAYMENT_SWIPEHQ_TEST_MODE == 'On') {
    $messageStack->add_session('header', MODULE_PAYMENT_SWIPEHQ_TEXT_TEST_MODE_MESSAGE, 'warning');
}

if (isset($_REQUEST['result']) && ($_REQUEST['result'] == 'accepted' || $_REQUEST['result'] == 'test-accepted') && isset($_REQUEST['user_data']) && ctype_digit($_REQUEST['user_data'])) {
    $order_id = $_REQUEST['user_data'];
    
    $order = new order($order_id);
    
    shq_send_emails();
    shq_clear_cart();
    
    $redirect_url = tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', $ssl_str, true, false);
} else {
    $messageStack->add_session('checkout_payment', MODULE_PAYMENT_SWIPEHQ_TEXT_PAYMENT_ERROR_MESSAGE, 'error');
    $redirect_url = tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', $ssl_str, true, false);
}
tep_redirect($redirect_url);



function shq_send_emails() {
    global $customer_id, $order, $order_totals, $sendto, $billto, $languages_id, $payment, $currencies, $cart, $products_ordered;
    global $$payment;
    
    $products_ordered   = $_SESSION['shq_products_ordered'];
    $order_totals       = $_SESSION['shq_order_totals'];
    $insert_id          = $_SESSION['shq_insert_id'];

  // lets start with the email confirmation
    $email_order = STORE_NAME . "\n" . 
                   EMAIL_SEPARATOR . "\n" . 
                   EMAIL_TEXT_ORDER_NUMBER . ' ' . $insert_id . "\n" .
                   EMAIL_TEXT_INVOICE_URL . ' ' . tep_href_link(FILENAME_ACCOUNT_HISTORY_INFO, 'order_id=' . $insert_id, 'SSL', false) . "\n" .
                   EMAIL_TEXT_DATE_ORDERED . ' ' . strftime(DATE_FORMAT_LONG) . "\n\n";
    if ($order->info['comments']) {
      $email_order .= tep_db_output($order->info['comments']) . "\n\n";
    }
    $email_order .= EMAIL_TEXT_PRODUCTS . "\n" . 
                    EMAIL_SEPARATOR . "\n" . 
                    $products_ordered . 
                    EMAIL_SEPARATOR . "\n";

    for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
      $email_order .= strip_tags($order_totals[$i]['title']) . ' ' . strip_tags($order_totals[$i]['text']) . "\n";
    }

    if ($order->content_type != 'virtual') {
      $email_order .= "\n" . EMAIL_TEXT_DELIVERY_ADDRESS . "\n" . 
                      EMAIL_SEPARATOR . "\n" .
                      tep_address_label($customer_id, $sendto, 0, '', "\n") . "\n";
    }

    $email_order .= "\n" . EMAIL_TEXT_BILLING_ADDRESS . "\n" .
                    EMAIL_SEPARATOR . "\n" .
                    tep_address_label($customer_id, $billto, 0, '', "\n") . "\n\n";
    if (is_object($$payment)) {
      $email_order .= EMAIL_TEXT_PAYMENT_METHOD . "\n" . 
                      EMAIL_SEPARATOR . "\n";
      $payment_class = $$payment;
      $email_order .= $order->info['payment_method'] . "\n\n";
      if (isset($payment_class->email_footer)) {
        $email_order .= $payment_class->email_footer . "\n\n";
      }
    }
    tep_mail($order->customer['firstname'] . ' ' . $order->customer['lastname'], $order->customer['email_address'], EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

  // send emails to other people
    if (SEND_EXTRA_ORDER_EMAILS_TO != '') {
      tep_mail('', SEND_EXTRA_ORDER_EMAILS_TO, EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
    }
}

function shq_clear_cart() {
    global $cart;

    $cart->reset(true);

  // unregister session variables used during checkout
    tep_session_unregister('sendto');
    tep_session_unregister('billto');
    tep_session_unregister('shipping');
    tep_session_unregister('payment');
    tep_session_unregister('comments');
}

function shq_get_products_ordered() {
    global $order;
    
    for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
        
    }
}